<% components = Decidim::Component
                .where(participatory_space_id: current_participatory_space.id)
                .select { |c| c.settings.respond_to?(:participatory_texts_enabled) && c.settings.participatory_texts_enabled } %>

<%= f.fields_for :properties do |participatory_texts_form| %>
  <%= participatory_texts_form.text_field :title, label: "Título", value: @home_element.properties['title'], placeholder: "Preencha o título da lista de textos participativos" %>
  <%= participatory_texts_form.text_field :description, label: "Descrição", value: @home_element.properties['description'], placeholder: "Preencha a descrição da lista de textos participativos" %>
  <%= participatory_texts_form.select :order, 
    options_for_select([['Mais recente', 'most_recent'], ['Mais antigo', 'oldest']], @home_element.properties['order']),
    { label: "Ordenar por" },
    { include_blank: "Escolha a ordem" } %>

  <div class="card-divider">
    <h2 class="card-title">Selecione os textos participativos que deseja exibir (por padrão todos são exibidos)</h2>
  </div>

  <% selected_ids = @home_element.properties["selected_participatory_text_ids"] || [] %>

  <% if components.any? %>
    <div class="card-section participatory-texts-grid">
      <% components.each do |component| %>
        <div>
          <%= check_box_tag(
                "home_elements[properties][selected_participatory_text_ids][]",
                component.id,
                selected_ids.map(&:to_s).include?(component.id.to_s),
                id: "component_#{component.id}",
                class: "participatory-checkbox"
              ) %>

          <%= label_tag("component_#{component.id}", translated_attribute(component.name)) %>
        </div>
      <% end %>
      <div class="reset-selection">
        <%= check_box_tag "reset_selection", "1", false, id: "reset-selection-checkbox" %>
        <%= label_tag "reset-selection-checkbox", "Selecionar todos" %>
      </div>
    </div>
  <% else %>
    <p class="no-texts">Nenhum texto participativo disponível ainda.</p>
  <% end %>
<% end %>

<style>
  .participatory-texts-grid {
    display: grid;
    grid-template-columns: repeat(auto-fill, minmax(300px, 1fr));
    grid-gap: 20px;
  }

  .no-texts {
    font-size: 16px;
    color: #888;
    text-align: center;
    margin-top: 15px;
  }
</style>

<script>
  document.addEventListener("DOMContentLoaded", function () {
    const resetCheckbox = document.getElementById("reset-selection-checkbox");
    const checkboxes = document.querySelectorAll(".participatory-checkbox");

    if (resetCheckbox) {
      resetCheckbox.checked = Array.from(checkboxes).every(cb => cb.checked);


      resetCheckbox.addEventListener("change", function () {
        checkboxes.forEach(cb => cb.checked = resetCheckbox.checked);
      });

      checkboxes.forEach(cb => {
        cb.addEventListener("change", function () {
          if (!cb.checked) {
            resetCheckbox.checked = false;
          }
        });
      });
    }
  });
</script>
